/*
    SDL - Simple DirectMedia Layer
    Copyright (C) 1997-2009 Sam Lantinga

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

    Sam Lantinga
    slouken@libsdl.org
*/
module org.libsdl.keysym;

enum SDLKey
{
	SDLK_UNKNOWN      = 0,
	SDLK_FIRST        = 0,
	SDLK_BACKSPACE    = 8,
	SDLK_TAB          = 9,
	SDLK_CLEAR        = 12,
	SDLK_RETURN       = 13,
	SDLK_PAUSE        = 19,
	SDLK_ESCAPE       = 27,
	SDLK_SPACE        = 32,
	SDLK_EXCLAIM      = 33,
	SDLK_QUOTEDBL     = 34,
	SDLK_HASH         = 35,
	SDLK_DOLLAR       = 36,
	SDLK_AMPERSAND    = 38,
	SDLK_QUOTE        = 39,
	SDLK_LEFTPAREN    = 40,
	SDLK_RIGHTPAREN   = 41,
	SDLK_ASTERISK     = 42,
	SDLK_PLUS         = 43,
	SDLK_COMMA        = 44,
	SDLK_MINUS        = 45,
	SDLK_PERIOD       = 46,
	SDLK_SLASH        = 47,
	SDLK_0            = 48,
	SDLK_1            = 49,
	SDLK_2            = 50,
	SDLK_3            = 51,
	SDLK_4            = 52,
	SDLK_5            = 53,
	SDLK_6            = 54,
	SDLK_7            = 55,
	SDLK_8            = 56,
	SDLK_9            = 57,
	SDLK_COLON        = 58,
	SDLK_SEMICOLON    = 59,
	SDLK_LESS         = 60,
	SDLK_EQUALS       = 61,
	SDLK_GREATER      = 62,
	SDLK_QUESTION     = 63,
	SDLK_AT           = 64,
	SDLK_LEFTBRACKET  = 91,
	SDLK_BACKSLASH    = 92,
	SDLK_RIGHTBRACKET = 93,
	SDLK_CARET        = 94,
	SDLK_UNDERSCORE   = 95,
	SDLK_BACKQUOTE    = 96,
	SDLK_a            = 97,
	SDLK_b            = 98,
	SDLK_c            = 99,
	SDLK_d            = 100,
	SDLK_e            = 101,
	SDLK_f            = 102,
	SDLK_g            = 103,
	SDLK_h            = 104,
	SDLK_i            = 105,
	SDLK_j            = 106,
	SDLK_k            = 107,
	SDLK_l            = 108,
	SDLK_m            = 109,
	SDLK_n            = 110,
	SDLK_o            = 111,
	SDLK_p            = 112,
	SDLK_q            = 113,
	SDLK_r            = 114,
	SDLK_s            = 115,
	SDLK_t            = 116,
	SDLK_u            = 117,
	SDLK_v            = 118,
	SDLK_w            = 119,
	SDLK_x            = 120,
	SDLK_y            = 121,
	SDLK_z            = 122,
	SDLK_DELETE       = 127,
	SDLK_WORLD_0      = 160,
	SDLK_WORLD_1      = 161,
	SDLK_WORLD_2      = 162,
	SDLK_WORLD_3      = 163,
	SDLK_WORLD_4      = 164,
	SDLK_WORLD_5      = 165,
	SDLK_WORLD_6      = 166,
	SDLK_WORLD_7      = 167,
	SDLK_WORLD_8      = 168,
	SDLK_WORLD_9      = 169,
	SDLK_WORLD_10     = 170,
	SDLK_WORLD_11     = 171,
	SDLK_WORLD_12     = 172,
	SDLK_WORLD_13     = 173,
	SDLK_WORLD_14     = 174,
	SDLK_WORLD_15     = 175,
	SDLK_WORLD_16     = 176,
	SDLK_WORLD_17     = 177,
	SDLK_WORLD_18     = 178,
	SDLK_WORLD_19     = 179,
	SDLK_WORLD_20     = 180,
	SDLK_WORLD_21     = 181,
	SDLK_WORLD_22     = 182,
	SDLK_WORLD_23     = 183,
	SDLK_WORLD_24     = 184,
	SDLK_WORLD_25     = 185,
	SDLK_WORLD_26     = 186,
	SDLK_WORLD_27     = 187,
	SDLK_WORLD_28     = 188,
	SDLK_WORLD_29     = 189,
	SDLK_WORLD_30     = 190,
	SDLK_WORLD_31     = 191,
	SDLK_WORLD_32     = 192,
	SDLK_WORLD_33     = 193,
	SDLK_WORLD_34     = 194,
	SDLK_WORLD_35     = 195,
	SDLK_WORLD_36     = 196,
	SDLK_WORLD_37     = 197,
	SDLK_WORLD_38     = 198,
	SDLK_WORLD_39     = 199,
	SDLK_WORLD_40     = 200,
	SDLK_WORLD_41     = 201,
	SDLK_WORLD_42     = 202,
	SDLK_WORLD_43     = 203,
	SDLK_WORLD_44     = 204,
	SDLK_WORLD_45     = 205,
	SDLK_WORLD_46     = 206,
	SDLK_WORLD_47     = 207,
	SDLK_WORLD_48     = 208,
	SDLK_WORLD_49     = 209,
	SDLK_WORLD_50     = 210,
	SDLK_WORLD_51     = 211,
	SDLK_WORLD_52     = 212,
	SDLK_WORLD_53     = 213,
	SDLK_WORLD_54     = 214,
	SDLK_WORLD_55     = 215,
	SDLK_WORLD_56     = 216,
	SDLK_WORLD_57     = 217,
	SDLK_WORLD_58     = 218,
	SDLK_WORLD_59     = 219,
	SDLK_WORLD_60     = 220,
	SDLK_WORLD_61     = 221,
	SDLK_WORLD_62     = 222,
	SDLK_WORLD_63     = 223,
	SDLK_WORLD_64     = 224,
	SDLK_WORLD_65     = 225,
	SDLK_WORLD_66     = 226,
	SDLK_WORLD_67     = 227,
	SDLK_WORLD_68     = 228,
	SDLK_WORLD_69     = 229,
	SDLK_WORLD_70     = 230,
	SDLK_WORLD_71     = 231,
	SDLK_WORLD_72     = 232,
	SDLK_WORLD_73     = 233,
	SDLK_WORLD_74     = 234,
	SDLK_WORLD_75     = 235,
	SDLK_WORLD_76     = 236,
	SDLK_WORLD_77     = 237,
	SDLK_WORLD_78     = 238,
	SDLK_WORLD_79     = 239,
	SDLK_WORLD_80     = 240,
	SDLK_WORLD_81     = 241,
	SDLK_WORLD_82     = 242,
	SDLK_WORLD_83     = 243,
	SDLK_WORLD_84     = 244,
	SDLK_WORLD_85     = 245,
	SDLK_WORLD_86     = 246,
	SDLK_WORLD_87     = 247,
	SDLK_WORLD_88     = 248,
	SDLK_WORLD_89     = 249,
	SDLK_WORLD_90     = 250,
	SDLK_WORLD_91     = 251,
	SDLK_WORLD_92     = 252,
	SDLK_WORLD_93     = 253,
	SDLK_WORLD_94     = 254,
	SDLK_WORLD_95     = 255,
	SDLK_KP0          = 256,
	SDLK_KP1          = 257,
	SDLK_KP2          = 258,
	SDLK_KP3          = 259,
	SDLK_KP4          = 260,
	SDLK_KP5          = 261,
	SDLK_KP6          = 262,
	SDLK_KP7          = 263,
	SDLK_KP8          = 264,
	SDLK_KP9          = 265,
	SDLK_KP_PERIOD    = 266,
	SDLK_KP_DIVIDE    = 267,
	SDLK_KP_MULTIPLY  = 268,
	SDLK_KP_MINUS     = 269,
	SDLK_KP_PLUS      = 270,
	SDLK_KP_ENTER     = 271,
	SDLK_KP_EQUALS    = 272,
 	SDLK_UP           = 273,
	SDLK_DOWN         = 274,
	SDLK_RIGHT        = 275,
	SDLK_LEFT         = 276,
	SDLK_INSERT       = 277,
	SDLK_HOME         = 278,
	SDLK_END          = 279,
	SDLK_PAGEUP       = 280,
	SDLK_PAGEDOWN     = 281,
	SDLK_F1           = 282,
	SDLK_F2           = 283,
	SDLK_F3           = 284,
	SDLK_F4           = 285,
	SDLK_F5           = 286,
	SDLK_F6           = 287,
	SDLK_F7           = 288,
	SDLK_F8           = 289,
	SDLK_F9           = 290,
	SDLK_F10          = 291,
	SDLK_F11          = 292,
	SDLK_F12          = 293,
	SDLK_F13          = 294,
	SDLK_F14          = 295,
	SDLK_F15          = 296,
	SDLK_NUMLOCK      = 300,
	SDLK_CAPSLOCK     = 301,
	SDLK_SCROLLOCK    = 302,
	SDLK_RSHIFT       = 303,
	SDLK_LSHIFT       = 304,
	SDLK_RCTRL        = 305,
	SDLK_LCTRL        = 306,
	SDLK_RALT         = 307,
	SDLK_LALT         = 308,
	SDLK_RMETA        = 309,
	SDLK_LMETA        = 310,
	SDLK_LSUPER       = 311,
	SDLK_RSUPER       = 312,
	SDLK_MODE         = 313,
	SDLK_COMPOSE      = 314,
	SDLK_HELP         = 315,
	SDLK_PRINT        = 316,
	SDLK_SYSREQ       = 317,
	SDLK_BREAK        = 318,
	SDLK_MENU         = 319,
	SDLK_POWER        = 320,
	SDLK_EURO         = 321,
	SDLK_UNDO         = 322,
	SDLK_LAST
}

alias SDLKey.SDLK_UNKNOWN SDLK_UNKNOWN;
alias SDLKey.SDLK_FIRST SDLK_FIRST;
alias SDLKey.SDLK_BACKSPACE SDLK_BACKSPACE;
alias SDLKey.SDLK_TAB SDLK_TAB;
alias SDLKey.SDLK_CLEAR SDLK_CLEAR;
alias SDLKey.SDLK_RETURN SDLK_RETURN;
alias SDLKey.SDLK_PAUSE SDLK_PAUSE;
alias SDLKey.SDLK_ESCAPE SDLK_ESCAPE;
alias SDLKey.SDLK_SPACE SDLK_SPACE;
alias SDLKey.SDLK_EXCLAIM SDLK_EXCLAIM;
alias SDLKey.SDLK_QUOTEDBL SDLK_QUOTEDBL;
alias SDLKey.SDLK_HASH SDLK_HASH;
alias SDLKey.SDLK_DOLLAR SDLK_DOLLAR;
alias SDLKey.SDLK_AMPERSAND SDLK_AMPERSAND;
alias SDLKey.SDLK_QUOTE SDLK_QUOTE;
alias SDLKey.SDLK_LEFTPAREN SDLK_LEFTPAREN;
alias SDLKey.SDLK_RIGHTPAREN SDLK_RIGHTPAREN;
alias SDLKey.SDLK_ASTERISK SDLK_ASTERISK;
alias SDLKey.SDLK_PLUS SDLK_PLUS;
alias SDLKey.SDLK_COMMA SDLK_COMMA;
alias SDLKey.SDLK_MINUS SDLK_MINUS;
alias SDLKey.SDLK_PERIOD SDLK_PERIOD;
alias SDLKey.SDLK_SLASH SDLK_SLASH;
alias SDLKey.SDLK_0 SDLK_0;
alias SDLKey.SDLK_1 SDLK_1;
alias SDLKey.SDLK_2 SDLK_2;
alias SDLKey.SDLK_3 SDLK_3;
alias SDLKey.SDLK_4 SDLK_4;
alias SDLKey.SDLK_5 SDLK_5;
alias SDLKey.SDLK_6 SDLK_6;
alias SDLKey.SDLK_7 SDLK_7;
alias SDLKey.SDLK_8 SDLK_8;
alias SDLKey.SDLK_9 SDLK_9;
alias SDLKey.SDLK_COLON SDLK_COLON;
alias SDLKey.SDLK_SEMICOLON SDLK_SEMICOLON;
alias SDLKey.SDLK_LESS SDLK_LESS;
alias SDLKey.SDLK_EQUALS SDLK_EQUALS;
alias SDLKey.SDLK_GREATER SDLK_GREATER;
alias SDLKey.SDLK_QUESTION SDLK_QUESTION;
alias SDLKey.SDLK_AT SDLK_AT;
alias SDLKey.SDLK_LEFTBRACKET SDLK_LEFTBRACKET;
alias SDLKey.SDLK_BACKSLASH SDLK_BACKSLASH;
alias SDLKey.SDLK_RIGHTBRACKET SDLK_RIGHTBRACKET;
alias SDLKey.SDLK_CARET SDLK_CARET;
alias SDLKey.SDLK_UNDERSCORE SDLK_UNDERSCORE;
alias SDLKey.SDLK_BACKQUOTE SDLK_BACKQUOTE;
alias SDLKey.SDLK_a SDLK_a;
alias SDLKey.SDLK_b SDLK_b;
alias SDLKey.SDLK_c SDLK_c;
alias SDLKey.SDLK_d SDLK_d;
alias SDLKey.SDLK_e SDLK_e;
alias SDLKey.SDLK_f SDLK_f;
alias SDLKey.SDLK_g SDLK_g;
alias SDLKey.SDLK_h SDLK_h;
alias SDLKey.SDLK_i SDLK_i;
alias SDLKey.SDLK_j SDLK_j;
alias SDLKey.SDLK_k SDLK_k;
alias SDLKey.SDLK_l SDLK_l;
alias SDLKey.SDLK_m SDLK_m;
alias SDLKey.SDLK_n SDLK_n;
alias SDLKey.SDLK_o SDLK_o;
alias SDLKey.SDLK_p SDLK_p;
alias SDLKey.SDLK_q SDLK_q;
alias SDLKey.SDLK_r SDLK_r;
alias SDLKey.SDLK_s SDLK_s;
alias SDLKey.SDLK_t SDLK_t;
alias SDLKey.SDLK_u SDLK_u;
alias SDLKey.SDLK_v SDLK_v;
alias SDLKey.SDLK_w SDLK_w;
alias SDLKey.SDLK_x SDLK_x;
alias SDLKey.SDLK_y SDLK_y;
alias SDLKey.SDLK_z SDLK_z;
alias SDLKey.SDLK_DELETE SDLK_DELETE;
alias SDLKey.SDLK_WORLD_0 SDLK_WORLD_0;
alias SDLKey.SDLK_WORLD_1 SDLK_WORLD_1;
alias SDLKey.SDLK_WORLD_2 SDLK_WORLD_2;
alias SDLKey.SDLK_WORLD_3 SDLK_WORLD_3;
alias SDLKey.SDLK_WORLD_4 SDLK_WORLD_4;
alias SDLKey.SDLK_WORLD_5 SDLK_WORLD_5;
alias SDLKey.SDLK_WORLD_6 SDLK_WORLD_6;
alias SDLKey.SDLK_WORLD_7 SDLK_WORLD_7;
alias SDLKey.SDLK_WORLD_8 SDLK_WORLD_8;
alias SDLKey.SDLK_WORLD_9 SDLK_WORLD_9;
alias SDLKey.SDLK_WORLD_10 SDLK_WORLD_10;
alias SDLKey.SDLK_WORLD_11 SDLK_WORLD_11;
alias SDLKey.SDLK_WORLD_12 SDLK_WORLD_12;
alias SDLKey.SDLK_WORLD_13 SDLK_WORLD_13;
alias SDLKey.SDLK_WORLD_14 SDLK_WORLD_14;
alias SDLKey.SDLK_WORLD_15 SDLK_WORLD_15;
alias SDLKey.SDLK_WORLD_16 SDLK_WORLD_16;
alias SDLKey.SDLK_WORLD_17 SDLK_WORLD_17;
alias SDLKey.SDLK_WORLD_18 SDLK_WORLD_18;
alias SDLKey.SDLK_WORLD_19 SDLK_WORLD_19;
alias SDLKey.SDLK_WORLD_20 SDLK_WORLD_20;
alias SDLKey.SDLK_WORLD_21 SDLK_WORLD_21;
alias SDLKey.SDLK_WORLD_22 SDLK_WORLD_22;
alias SDLKey.SDLK_WORLD_23 SDLK_WORLD_23;
alias SDLKey.SDLK_WORLD_24 SDLK_WORLD_24;
alias SDLKey.SDLK_WORLD_25 SDLK_WORLD_25;
alias SDLKey.SDLK_WORLD_26 SDLK_WORLD_26;
alias SDLKey.SDLK_WORLD_27 SDLK_WORLD_27;
alias SDLKey.SDLK_WORLD_28 SDLK_WORLD_28;
alias SDLKey.SDLK_WORLD_29 SDLK_WORLD_29;
alias SDLKey.SDLK_WORLD_30 SDLK_WORLD_30;
alias SDLKey.SDLK_WORLD_31 SDLK_WORLD_31;
alias SDLKey.SDLK_WORLD_32 SDLK_WORLD_32;
alias SDLKey.SDLK_WORLD_33 SDLK_WORLD_33;
alias SDLKey.SDLK_WORLD_34 SDLK_WORLD_34;
alias SDLKey.SDLK_WORLD_35 SDLK_WORLD_35;
alias SDLKey.SDLK_WORLD_36 SDLK_WORLD_36;
alias SDLKey.SDLK_WORLD_37 SDLK_WORLD_37;
alias SDLKey.SDLK_WORLD_38 SDLK_WORLD_38;
alias SDLKey.SDLK_WORLD_39 SDLK_WORLD_39;
alias SDLKey.SDLK_WORLD_40 SDLK_WORLD_40;
alias SDLKey.SDLK_WORLD_41 SDLK_WORLD_41;
alias SDLKey.SDLK_WORLD_42 SDLK_WORLD_42;
alias SDLKey.SDLK_WORLD_43 SDLK_WORLD_43;
alias SDLKey.SDLK_WORLD_44 SDLK_WORLD_44;
alias SDLKey.SDLK_WORLD_45 SDLK_WORLD_45;
alias SDLKey.SDLK_WORLD_46 SDLK_WORLD_46;
alias SDLKey.SDLK_WORLD_47 SDLK_WORLD_47;
alias SDLKey.SDLK_WORLD_48 SDLK_WORLD_48;
alias SDLKey.SDLK_WORLD_49 SDLK_WORLD_49;
alias SDLKey.SDLK_WORLD_50 SDLK_WORLD_50;
alias SDLKey.SDLK_WORLD_51 SDLK_WORLD_51;
alias SDLKey.SDLK_WORLD_52 SDLK_WORLD_52;
alias SDLKey.SDLK_WORLD_53 SDLK_WORLD_53;
alias SDLKey.SDLK_WORLD_54 SDLK_WORLD_54;
alias SDLKey.SDLK_WORLD_55 SDLK_WORLD_55;
alias SDLKey.SDLK_WORLD_56 SDLK_WORLD_56;
alias SDLKey.SDLK_WORLD_57 SDLK_WORLD_57;
alias SDLKey.SDLK_WORLD_58 SDLK_WORLD_58;
alias SDLKey.SDLK_WORLD_59 SDLK_WORLD_59;
alias SDLKey.SDLK_WORLD_60 SDLK_WORLD_60;
alias SDLKey.SDLK_WORLD_61 SDLK_WORLD_61;
alias SDLKey.SDLK_WORLD_62 SDLK_WORLD_62;
alias SDLKey.SDLK_WORLD_63 SDLK_WORLD_63;
alias SDLKey.SDLK_WORLD_64 SDLK_WORLD_64;
alias SDLKey.SDLK_WORLD_65 SDLK_WORLD_65;
alias SDLKey.SDLK_WORLD_66 SDLK_WORLD_66;
alias SDLKey.SDLK_WORLD_67 SDLK_WORLD_67;
alias SDLKey.SDLK_WORLD_68 SDLK_WORLD_68;
alias SDLKey.SDLK_WORLD_69 SDLK_WORLD_69;
alias SDLKey.SDLK_WORLD_70 SDLK_WORLD_70;
alias SDLKey.SDLK_WORLD_71 SDLK_WORLD_71;
alias SDLKey.SDLK_WORLD_72 SDLK_WORLD_72;
alias SDLKey.SDLK_WORLD_73 SDLK_WORLD_73;
alias SDLKey.SDLK_WORLD_74 SDLK_WORLD_74;
alias SDLKey.SDLK_WORLD_75 SDLK_WORLD_75;
alias SDLKey.SDLK_WORLD_76 SDLK_WORLD_76;
alias SDLKey.SDLK_WORLD_77 SDLK_WORLD_77;
alias SDLKey.SDLK_WORLD_78 SDLK_WORLD_78;
alias SDLKey.SDLK_WORLD_79 SDLK_WORLD_79;
alias SDLKey.SDLK_WORLD_80 SDLK_WORLD_80;
alias SDLKey.SDLK_WORLD_81 SDLK_WORLD_81;
alias SDLKey.SDLK_WORLD_82 SDLK_WORLD_82;
alias SDLKey.SDLK_WORLD_83 SDLK_WORLD_83;
alias SDLKey.SDLK_WORLD_84 SDLK_WORLD_84;
alias SDLKey.SDLK_WORLD_85 SDLK_WORLD_85;
alias SDLKey.SDLK_WORLD_86 SDLK_WORLD_86;
alias SDLKey.SDLK_WORLD_87 SDLK_WORLD_87;
alias SDLKey.SDLK_WORLD_88 SDLK_WORLD_88;
alias SDLKey.SDLK_WORLD_89 SDLK_WORLD_89;
alias SDLKey.SDLK_WORLD_90 SDLK_WORLD_90;
alias SDLKey.SDLK_WORLD_91 SDLK_WORLD_91;
alias SDLKey.SDLK_WORLD_92 SDLK_WORLD_92;
alias SDLKey.SDLK_WORLD_93 SDLK_WORLD_93;
alias SDLKey.SDLK_WORLD_94 SDLK_WORLD_94;
alias SDLKey.SDLK_WORLD_95 SDLK_WORLD_95;
alias SDLKey.SDLK_KP0 SDLK_KP0;
alias SDLKey.SDLK_KP1 SDLK_KP1;
alias SDLKey.SDLK_KP2 SDLK_KP2;
alias SDLKey.SDLK_KP3 SDLK_KP3;
alias SDLKey.SDLK_KP4 SDLK_KP4;
alias SDLKey.SDLK_KP5 SDLK_KP5;
alias SDLKey.SDLK_KP6 SDLK_KP6;
alias SDLKey.SDLK_KP7 SDLK_KP7;
alias SDLKey.SDLK_KP8 SDLK_KP8;
alias SDLKey.SDLK_KP9 SDLK_KP9;
alias SDLKey.SDLK_KP_PERIOD SDLK_KP_PERIOD;
alias SDLKey.SDLK_KP_DIVIDE SDLK_KP_DIVIDE;
alias SDLKey.SDLK_KP_MULTIPLY SDLK_KP_MULTIPLY;
alias SDLKey.SDLK_KP_MINUS SDLK_KP_MINUS;
alias SDLKey.SDLK_KP_PLUS SDLK_KP_PLUS;
alias SDLKey.SDLK_KP_ENTER SDLK_KP_ENTER;
alias SDLKey.SDLK_KP_EQUALS SDLK_KP_EQUALS;
alias SDLKey.SDLK_UP SDLK_UP;
alias SDLKey.SDLK_DOWN SDLK_DOWN;
alias SDLKey.SDLK_RIGHT SDLK_RIGHT;
alias SDLKey.SDLK_LEFT SDLK_LEFT;
alias SDLKey.SDLK_INSERT SDLK_INSERT;
alias SDLKey.SDLK_HOME SDLK_HOME;
alias SDLKey.SDLK_END SDLK_END;
alias SDLKey.SDLK_PAGEUP SDLK_PAGEUP;
alias SDLKey.SDLK_PAGEDOWN SDLK_PAGEDOWN;
alias SDLKey.SDLK_F1 SDLK_F1;
alias SDLKey.SDLK_F2 SDLK_F2;
alias SDLKey.SDLK_F3 SDLK_F3;
alias SDLKey.SDLK_F4 SDLK_F4;
alias SDLKey.SDLK_F5 SDLK_F5;
alias SDLKey.SDLK_F6 SDLK_F6;
alias SDLKey.SDLK_F7 SDLK_F7;
alias SDLKey.SDLK_F8 SDLK_F8;
alias SDLKey.SDLK_F9 SDLK_F9;
alias SDLKey.SDLK_F10 SDLK_F10;
alias SDLKey.SDLK_F11 SDLK_F11;
alias SDLKey.SDLK_F12 SDLK_F12;
alias SDLKey.SDLK_F13 SDLK_F13;
alias SDLKey.SDLK_F14 SDLK_F14;
alias SDLKey.SDLK_F15 SDLK_F15;
alias SDLKey.SDLK_NUMLOCK SDLK_NUMLOCK;
alias SDLKey.SDLK_CAPSLOCK SDLK_CAPSLOCK;
alias SDLKey.SDLK_SCROLLOCK SDLK_SCROLLOCK;
alias SDLKey.SDLK_RSHIFT SDLK_RSHIFT;
alias SDLKey.SDLK_LSHIFT SDLK_LSHIFT;
alias SDLKey.SDLK_RCTRL SDLK_RCTRL;
alias SDLKey.SDLK_LCTRL SDLK_LCTRL;
alias SDLKey.SDLK_RALT SDLK_RALT;
alias SDLKey.SDLK_LALT SDLK_LALT;
alias SDLKey.SDLK_RMETA SDLK_RMETA;
alias SDLKey.SDLK_LMETA SDLK_LMETA;
alias SDLKey.SDLK_LSUPER SDLK_LSUPER;
alias SDLKey.SDLK_RSUPER SDLK_RSUPER;
alias SDLKey.SDLK_MODE SDLK_MODE;
alias SDLKey.SDLK_COMPOSE SDLK_COMPOSE;
alias SDLKey.SDLK_HELP SDLK_HELP;
alias SDLKey.SDLK_PRINT SDLK_PRINT;
alias SDLKey.SDLK_SYSREQ SDLK_SYSREQ;
alias SDLKey.SDLK_BREAK SDLK_BREAK;
alias SDLKey.SDLK_MENU SDLK_MENU;
alias SDLKey.SDLK_POWER SDLK_POWER;
alias SDLKey.SDLK_EURO SDLK_EURO;
alias SDLKey.SDLK_UNDO SDLK_UNDO;
alias SDLKey.SDLK_LAST SDLK_LAST;

enum SDLMod
{
	KMOD_NONE     = 0x0000,
	KMOD_LSHIFT   = 0x0001,
	KMOD_RSHIFT   = 0x0002,
	KMOD_LCTRL    = 0x0040,
	KMOD_RCTRL    = 0x0080,
	KMOD_LALT     = 0x0100,
	KMOD_RALT     = 0x0200,
	KMOD_LMETA    = 0x0400,
	KMOD_RMETA    = 0x0800,
	KMOD_NUM      = 0x1000,
	KMOD_CAPS     = 0x2000,
	KMOD_MODE     = 0x4000,
	KMOD_RESERVED = 0x8000
}

alias SDLMod.KMOD_NONE KMOD_NONE;
alias SDLMod.KMOD_LSHIFT KMOD_LSHIFT;
alias SDLMod.KMOD_RSHIFT KMOD_RSHIFT;
alias SDLMod.KMOD_LCTRL KMOD_LCTRL;
alias SDLMod.KMOD_RCTRL KMOD_RCTRL;
alias SDLMod.KMOD_LALT KMOD_LALT;
alias SDLMod.KMOD_RALT KMOD_RALT;
alias SDLMod.KMOD_LMETA KMOD_LMETA;
alias SDLMod.KMOD_RMETA KMOD_RMETA;
alias SDLMod.KMOD_NUM KMOD_NUM;
alias SDLMod.KMOD_CAPS KMOD_CAPS;
alias SDLMod.KMOD_MODE KMOD_MODE;
alias SDLMod.KMOD_RESERVED KMOD_RESERVED;

immutable int KMOD_CTRL  = SDLMod.KMOD_LCTRL | SDLMod.KMOD_RCTRL;
immutable int KMOD_SHIFT = SDLMod.KMOD_LSHIFT | SDLMod.KMOD_RSHIFT;
immutable int KMOD_ALT   = SDLMod.KMOD_LALT | SDLMod.KMOD_RALT;
immutable int KMOD_META  = SDLMod.KMOD_LMETA | SDLMod.KMOD_RMETA;
